const N = require("./questions-based-key.js").N;
const scrypt = require("scrypt-js");
const buffer = require("buffer");

module.exports.N = N;
module.exports = function(nonce, password, onProgress){
    return new Promise(function(resolve, reject){
        const dkLen = 64; // 512 bits, let's fight against quantum computers :)
        const r = 8;
        const p = 1;
        scrypt(
            new buffer.Buffer(password.normalize("NFKC")),
            nonce, N, r, p, dkLen,
            function(error, progress, key){
                if(error){
                    return reject(error);
                }
                if(progress){
                    onProgress(progress * 100);
                }
                if(key){
                    return resolve(new buffer.Buffer(key).toString("base64"));
                }
            }
        );
    });
}
