const scrypt = require("scrypt-js");
const buffer = require("buffer");
//const N = 1048576;
const N = 65536; // for dev

module.exports = async function (nonce, questions, onProgress){
    /* Generates a determinstic key based on questions and nonce. */
    var order = Object.keys(questions);
    var hashsource = [];
    order.sort();
    order.forEach(function(name){
        hashsource.push(name + "=" + questions[name].answer);
    });
    hashsource = new buffer.Buffer(hashsource.join("|").normalize("NFKC"));

    return new Promise(function(resolve, reject){
        const dkLen = 64; // 512 bits, let's fight against quantum computers :)
        const r = 8;
        const p = 1;
        scrypt(
            hashsource, nonce, N, r, p, dkLen,
            function(error, progress, key){
                if(error){
                    return reject(error);
                }
                if(progress){
                    onProgress(progress * 100);
                }
                if(key){
                    return resolve(new buffer.Buffer(key).toString("base64"));
                }
            }
        );
    });
}
module.exports.N = N;
